<h1>205.1 Functional Programming</h1>

<p align="center">
    <img src="icon.svg" width="80" alt="Lambda in the colors of the Scala logo (red)">
</p>

---
<h2>Table of Contents</h2>
<!-- TOC -->
  * [Lessons](#lessons)
    * [Lesson 1 - Evaluation](#lesson-1---evaluation)
    * [Lesson 2 - Higher order functions](#lesson-2---higher-order-functions)
    * [Lesson 3 - Data structures](#lesson-3---data-structures)
  * [Assignments](#assignments)
    * [Assignment 1 - Square root](#assignment-1---square-root)
    * [Assignment 2 - Map-reduce](#assignment-2---map-reduce)
    * [Assignment 3 - Binary tree](#assignment-3---binary-tree)
<!-- TOC -->
---

## Lessons

### Lesson 1 - Evaluation
[Files](src/Lesson1)
- Call by name / Call by value
- State-less functions

### Lesson 2 - Higher order functions
[Files](src/Lesson2)
- Curryfication
- Recursion
- Tail recursion

### Lesson 3 - Data structures
[Files](src/Lesson3)
- Functional data structures
- Binary tree
- Operation precedence

## Assignments

### Assignment 1 - Square root
[Files](src/Assignment1)
- Recursion
- Newton
- Tail recursion

### Assignment 2 - Map-reduce
[Files](src/Assignment2)
- Fibonacci
- Sum
- Map-reduce

### Assignment 3 - Binary tree
[Files](src/Assignment3)
- Int set
- Binary tree
- Union / intersection / foreach
